
globals [
  industrias-x industrias-y
  industria-patches   #obreros
  sample-obrero

  ]


breed[obreros obrero]                                                ;razas

breed [industrias industria]


obreros-own [
  personalocupado nivel-ingreso costo-transporte xo yo               ;caracteristicas de los agentes
  velocidad velocidad-max velocidad-min]

industrias-own [
  concentracion xc yc velocidad velocidad-min velocidad-max]

patches-own [
  distancia]

;;;;;;;;;;;;comenzar;;;;;;;;;
to setup                                                             ; comenzar
  clear-all
  setup-patches1                                                     ; limpiar el mundo
  set industria-patches "distancia"

                                                                     ;Se limpia el mundo
    create-obreros obreros-personalocupado                           ;Se crean los obreros que son la representacion del total de personal ocupado del sector manufacturero
    [
 set nivel-ingreso round random-normal 50 10                         ;Se les asigna un nivel de ingreso
 set costo-transporte round random-normal 5 3                        ;Se les asigna un costo promedio de transporte
 set shape "car"                                                     ;Se le asigna forma de carro a los obreros para una ejemplificacion de la movilidad
 set size 0.8                                                        ;Se le asigna un tamaño especifico
 setxy random-pxcor random-pycor                                     ;Con esta instruccion los agentes se colocan aleatoriamente en el mundo
 set color red                                                       ;Se asigna color rojo a los agentes

 set velocidad 0.1 + random-float 0.9                                ;Se asigna la caracteristica relacionada con el movimiento de los agentes en este caso, una velocidad máxima y mínima
    set velocidad-max 1
    set velocidad-min 0
    separate-obreros

   set xo xcor
   set yo ycor  ]

 reset-ticks
end

to separate-obreros                                                  ;Se escribe el procedimiento para que los agentes no se traslapen y se separen en su trayectoria hacía su lugar destino
  if any? other turtles-here [
    fd 1
    separate-obreros
  ]
end


to setup-patches                                                     ;Inicializar los patches
  ask patches [                                                      ;Caracterizar patches
    set distancia min [distance myself] of industrias                ;Calcular la distancia entre cada uno de los patches y los centros económicos.


   ]
end

to actualizar-color-patche                                          ;Actualizar la vista del mundo.
  if industria-patches = "distancia"                                ;Ver en modo de radio de distancia a partir del centro económico.
    [set pcolor scale-color black distancia
       (.35 * ( max-pxcor * 1.414 ) )
       ( 0.05 * ( max-pxcor * 1.414 ) )]                            ;Pintar los patches con una escala de color que se degrada mientras mas se aleja del centro económico.
end

;;;;;;;;;;;;;;;GO;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

  to go

    ask obreros                                                      ;Se da la instruccion al agente obreros que se muevan por los patches de color blanco
[ move-to one-of patches with [ pcolor = white ] fd 0.5 ]
ask obreros
 [ move-to one-of industrias ]                                       ;Esta indicacion es para indicarle a los agentes que se muevan hacía donde esta colocada la industria
;;;;;;;;
;;;;;;;;

  ask turtles[                                                       ;Este procedimiento indica al agente que su marcha se haga más lenta cuando choque con otro agente
    let obreros-ahead one-of turtles-on patch-ahead 1
    ifelse obreros-ahead != nobody
      [ slow-down-obreros obreros-ahead ]
      [ speed-up-obreros ]
                                                                     ;Se da la indicacion de velocidad a los agentes
    if velocidad < velocidad-min [ set velocidad velocidad-min ]
    if velocidad > velocidad-max [ set velocidad velocidad-max ]
    fd velocidad
  ]
  tick
end


to slow-down-obreros [ obreros-ahead ]                               ;Se da la instruccion al agente de ir despacio segun si cruza con algun otro agente

  if Obreros-personalocupado > 500 [                                 ;Cuando los agentes en el mundo superan los 500, la trayectoria de los agentes disminuye su velocidad
  set velocidad [ velocidad ] of obreros-ahead - deceleration]
end


to speed-up-obreros                                                  ;La velocidad de los agetes cambiara segun el deslizador de agentes interactuando en el espacio
   if Obreros-personalocupado < 500 [
  set velocidad velocidad + acceleration]
end





  to setup-patches1
    ask patches[                                                      ;este es el procedimiento para dibujar una cuadricula en el mundo, por donde transitarán los agentes desde su punto origen a su punto destino
        let grid-x-inc world-width / 7
  let grid-y-inc world-height / 7
    let roads patches with
    [(floor((pxcor + max-pxcor - floor(grid-x-inc - 1)) mod grid-x-inc) = 0) or
    (floor((pycor + max-pycor) mod grid-y-inc) = 0)]
  let intersections roads with
    [(floor((pxcor + max-pxcor - floor(grid-x-inc - 1)) mod grid-x-inc) = 0) and
    (floor((pycor + max-pycor) mod grid-y-inc) = 0)]

  ask roads [ set pcolor white ]]

  end



;;;;;;;;;;;;;;;;;;;;;;;;
;;; indicaciones con el ratón de computadora ;;;
;;;;;;;;;;;;;;;;;;;;;;;;

to do-mouse-action                                                    ;En este caso se dan las indicaciones a relaizar mediante la ayuda del mouse
  run mouse-action
end

to add-new-industria                                                  ;Para crear un nuevo ccentro industrial
  while [mouse-down?] [
    wait .1

    if not mouse-down? [
      create-industrias 1 [
        set shape "factory"
        set size 5
        setxy mouse-xcor mouse-ycor
      ]
      display
    ]
  ]
end

to remove-industria                                                   ;Para quitar un centro industrial
  if mouse-down? [
    let candidate min-one-of industrias [distancexy mouse-xcor mouse-ycor]
    if [distancexy mouse-xcor mouse-ycor] of candidate < 1 [
      ask candidate [die]
      display
    ]
  ]
end

to move-industria                                                     ;Para mover un centro industrial
   if mouse-down? [
    let candidate min-one-of industrias [distancexy mouse-xcor mouse-ycor]
    if [distancexy mouse-xcor mouse-ycor] of candidate < 1 [
      while [mouse-down?] [
        go
        ask candidate [ setxy mouse-xcor mouse-ycor ]
      ]
    ]
  ]
end
@#$#@#$#@
GRAPHICS-WINDOW
223
10
697
505
25
25
9.103
1
10
1
1
1
0
1
1
1
-25
25
-25
25
0
0
1
ticks
30.0

BUTTON
24
39
87
72
NIL
setup
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
26
98
89
131
go
go
T
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

SLIDER
22
158
209
191
Obreros-personalocupado
Obreros-personalocupado
1
1000
384
1
1
NIL
HORIZONTAL

CHOOSER
23
227
172
272
mouse-action
mouse-action
"add-new-industria" "remove-industria" "move-industria"
0

BUTTON
30
287
154
320
do-mouse-action
do-mouse-action
T
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
115
106
182
139
go tick
go
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

SLIDER
22
335
194
368
acceleration
acceleration
0
.0099
0.0045
.0001
1
NIL
HORIZONTAL

SLIDER
27
383
199
416
deceleration
deceleration
0
.099
0.026
.001
1
NIL
HORIZONTAL

PLOT
733
37
933
187
plot 1
NIL
NIL
0.0
100000.0
0.0
1.0
true
false
"" ""
PENS
"default" 1.0 0 -16777216 true "" "plot sum [velocidad] of obreros / count obreros"

TEXTBOX
722
221
872
333
Despues de iniciar el mundo mediante el boton setup, se deberá colocar un centro economico en el mundo para poder correr el modelo, despues de realizar este procedimiento se puede dar inicio con el boton GO
11
0.0
1

@#$#@#$#@
## ¿Que es?

Este modelo pretende modelar los desplazamientos de la clase obrera, de su lugar de vivienda a su lugar de trabajo. En donde existen centros economicos colocados a consideracion del ejecutor de la programacion en un sentido de que donde se genere el centro industrial, sera el centro captador de trabajo en donde lo que se mide es la velocidad de los tiempos promedio de trayecto de un punto origen a un punto destino ya que cada paso del tiempo (tick) es considerado como un desplazamiento con un tiempo promedio de viaje y a medida que se incrementa el numero de trabajadores en movimiento, los desplazamientos se hacen más lentos y por tanto el tiempo promedio aumenta generando tráfico

## ¿Cómo funciona?

En este mundo los agentes se desplazarán de su lugar de vivienda a su puesto de trabajo transitando por las vias de comunicacion disponibles, de acuerdo a las ruta de transporte, en donde solo existen dos agentes, los trabajadores y el centro industrial que capta el trabajo es decir el punto aleatoria donde se coloca al trabajador es el punto origen y el punto destino es el que se coloca mediante el mouse directamente a la posicion que se quiere que ocupe en el mundo teniendo la noción de que este centro industrial representa al centro industrial de la ZMVM

La regla de transicion para este modelo consiste en la interaccion entre los agentes cada vez que estos chocan entre si cuando ocurre una aglomeracion reduciendo asi la velocidad de su trayectoria.

## ¿Cómo se usa?

mediante un boton de inicio se genera el mundo con un numero de trabajadores y empresas especificos, que se moveran de acuerdo a donde se localiza el atractor de trabajo, y con ayuda de algunos deslizadores se plantearan escenarios en los cuales se podrá ver la velocidad de los desplazamientos

## THINGS TO NOTICE

Al correr el modelo se podra ver como los desplazamientos ocurren de acuerdo a los diferentes numero de personas transitando por las vias de comunicacion generando las aglomeraciones cada que aumenta el numero de trabajadores

## THINGS TO TRY

(suggested things for the user to try to do (move sliders, switches, etc.) with the model)

## EXTENDING THE MODEL

(suggested things to add or change in the Code tab to make the model more complicated, detailed, accurate, etc.)

## NETLOGO FEATURES

(interesting or unusual features of NetLogo that the model uses, particularly in the Code tab; or where workarounds were needed for missing features)

## RELATED MODELS

(models in the NetLogo Models Library and elsewhere which are of related interest)

## CREDITS AND REFERENCES

(a reference to the model's URL on the web if it has one, as well as any other necessary credits, citations, and links)
@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

airplane
true
0
Polygon -7500403 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7500403 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

box
false
0
Polygon -7500403 true true 150 285 285 225 285 75 150 135
Polygon -7500403 true true 150 135 15 75 150 15 285 75
Polygon -7500403 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7500403 true true 96 182 108
Circle -7500403 true true 110 127 80
Circle -7500403 true true 110 75 80
Line -7500403 true 150 100 80 30
Line -7500403 true 150 100 220 30

butterfly
true
0
Polygon -7500403 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7500403 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7500403 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7500403 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7500403 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7500403 true true 47 195 58
Circle -7500403 true true 195 195 58

circle
false
0
Circle -7500403 true true 0 0 300

circle 2
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240

cow
false
0
Polygon -7500403 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7500403 true true 73 210 86 251 62 249 48 208
Polygon -7500403 true true 25 114 16 195 9 204 23 213 25 200 39 123

cylinder
false
0
Circle -7500403 true true 0 0 300

dot
false
0
Circle -7500403 true true 90 90 120

face happy
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7500403 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

factory
false
0
Rectangle -7500403 true true 76 194 285 270
Rectangle -7500403 true true 36 95 59 231
Rectangle -16777216 true false 90 210 270 240
Line -7500403 true 90 195 90 255
Line -7500403 true 120 195 120 255
Line -7500403 true 150 195 150 240
Line -7500403 true 180 195 180 255
Line -7500403 true 210 210 210 240
Line -7500403 true 240 210 240 240
Line -7500403 true 90 225 270 225
Circle -1 true false 37 73 32
Circle -1 true false 55 38 54
Circle -1 true false 96 21 42
Circle -1 true false 105 40 32
Circle -1 true false 129 19 42
Rectangle -7500403 true true 14 228 78 270

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7500403 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7500403 true true 60 15 75 300
Polygon -7500403 true true 90 150 270 90 90 30
Line -7500403 true 75 135 90 135
Line -7500403 true 75 45 90 45

flower
false
0
Polygon -10899396 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7500403 true true 85 132 38
Circle -7500403 true true 130 147 38
Circle -7500403 true true 192 85 38
Circle -7500403 true true 85 40 38
Circle -7500403 true true 177 40 38
Circle -7500403 true true 177 132 38
Circle -7500403 true true 70 85 38
Circle -7500403 true true 130 25 38
Circle -7500403 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -10899396 true false 189 233 219 188 249 173 279 188 234 218
Polygon -10899396 true false 180 255 150 210 105 210 75 240 135 240

house
false
0
Rectangle -7500403 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7500403 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

leaf
false
0
Polygon -7500403 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7500403 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7500403 true 150 0 150 300

line half
true
0
Line -7500403 true 150 0 150 150

pentagon
false
0
Polygon -7500403 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7500403 true true 110 5 80
Polygon -7500403 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7500403 true true 127 79 172 94
Polygon -7500403 true true 195 90 240 150 225 180 165 105
Polygon -7500403 true true 105 90 60 150 75 180 135 105

plant
false
0
Rectangle -7500403 true true 135 90 165 300
Polygon -7500403 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7500403 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7500403 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7500403 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7500403 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7500403 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7500403 true true 135 90 120 45 150 15 180 45 165 90

sheep
false
15
Circle -1 true true 203 65 88
Circle -1 true true 70 65 162
Circle -1 true true 150 105 120
Polygon -7500403 true false 218 120 240 165 255 165 278 120
Circle -7500403 true false 214 72 67
Rectangle -1 true true 164 223 179 298
Polygon -1 true true 45 285 30 285 30 240 15 195 45 210
Circle -1 true true 3 83 150
Rectangle -1 true true 65 221 80 296
Polygon -1 true true 195 285 210 285 210 240 240 210 195 210
Polygon -7500403 true false 276 85 285 105 302 99 294 83
Polygon -7500403 true false 219 85 210 105 193 99 201 83

square
false
0
Rectangle -7500403 true true 30 30 270 270

square 2
false
0
Rectangle -7500403 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7500403 true true 151 1 185 108 298 108 207 175 242 282 151 216 59 282 94 175 3 108 116 108

target
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7500403 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7500403 true true 120 120 60

tree
false
0
Circle -7500403 true true 118 3 94
Rectangle -6459832 true false 120 195 180 300
Circle -7500403 true true 65 21 108
Circle -7500403 true true 116 41 127
Circle -7500403 true true 45 90 120
Circle -7500403 true true 104 74 152

triangle
false
0
Polygon -7500403 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7500403 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7500403 true true 4 45 195 187
Polygon -7500403 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7500403 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7500403 false true 24 174 42
Circle -7500403 false true 144 174 42
Circle -7500403 false true 234 174 42

turtle
true
0
Polygon -10899396 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -10899396 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -10899396 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -10899396 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -10899396 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7500403 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

wheel
false
0
Circle -7500403 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7500403 true 150 285 150 15
Line -7500403 true 15 150 285 150
Circle -7500403 true true 120 120 60
Line -7500403 true 216 40 79 269
Line -7500403 true 40 84 269 221
Line -7500403 true 40 216 269 79
Line -7500403 true 84 40 221 269

wolf
false
0
Polygon -16777216 true false 253 133 245 131 245 133
Polygon -7500403 true true 2 194 13 197 30 191 38 193 38 205 20 226 20 257 27 265 38 266 40 260 31 253 31 230 60 206 68 198 75 209 66 228 65 243 82 261 84 268 100 267 103 261 77 239 79 231 100 207 98 196 119 201 143 202 160 195 166 210 172 213 173 238 167 251 160 248 154 265 169 264 178 247 186 240 198 260 200 271 217 271 219 262 207 258 195 230 192 198 210 184 227 164 242 144 259 145 284 151 277 141 293 140 299 134 297 127 273 119 270 105
Polygon -7500403 true true -1 195 14 180 36 166 40 153 53 140 82 131 134 133 159 126 188 115 227 108 236 102 238 98 268 86 269 92 281 87 269 103 269 113

x
false
0
Polygon -7500403 true true 270 75 225 30 30 225 75 270
Polygon -7500403 true true 30 75 75 30 270 225 225 270

@#$#@#$#@
NetLogo 5.2.1
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
<experiments>
  <experiment name="experiment" repetitions="5" runMetricsEveryStep="true">
    <setup>setup</setup>
    <go>go</go>
    <metric>plot sum [velocidad] of obreros / count obreros</metric>
    <enumeratedValueSet variable="acceleration">
      <value value="0.0045"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="deceleration">
      <value value="0.026"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Obreros-personalocupado">
      <value value="338"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="mouse-action">
      <value value="&quot;add-new-industria&quot;"/>
    </enumeratedValueSet>
  </experiment>
</experiments>
@#$#@#$#@
@#$#@#$#@
default
0.0
-0.2 0 0.0 1.0
0.0 1 1.0 0.0
0.2 0 0.0 1.0
link direction
true
0
Line -7500403 true 150 150 90 180
Line -7500403 true 150 150 210 180

@#$#@#$#@
0
@#$#@#$#@
